# sc::SCElementKNorm Class Reference

Computed k-norm of matrix. More...

`#include <elemop.h>`

Inheritance diagram for sc::SCElementKNorm:

List of all members.

## Public Member Functions

| SCElementKNorm (double k=2.0)
| by default compute 2-norm
| SCElementKNorm (StateIn &)
void | save_data_state (StateOut &)
| Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.
void | process (SCMatrixBlockIter &)
| This is the fallback routine to process blocks and is called by process_spec members that are not overridden.
int | has_collect ()
| If duplicates of the SCElementOp exist (that is, there is more than one node), then if has_collect returns nonzero then collect is called with a MessageGrp reference after all of the blocks have been processed.
void | defer_collect (int)
void | collect (const Ref< MessageGrp > &)
void | collect (const Ref< SCElementOp > &)
| Multithreaded use of cloneable SCElementOp objects requires that data from cloned objects be collected.
double | result ()
void | init ()

## Detailed Description

Computed k-norm of matrix.

## Member Function Documentation

void sc::SCElementKNorm::save_data_state | ( | StateOut & |  | ) | `[virtual]`

Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.

This must be implemented by the derived class if the class has data.

Reimplemented from sc::SavableState.

void sc::SCElementKNorm::process | ( | SCMatrixBlockIter & |  | ) | `[virtual]`

This is the fallback routine to process blocks and is called by process_spec members that are not overridden.

Implements sc::SCElementOp.

int sc::SCElementKNorm::has_collect | ( |  | ) | `[virtual]`

If duplicates of the SCElementOp exist (that is, there is more than one node), then if has_collect returns nonzero then collect is called with a MessageGrp reference after all of the blocks have been processed.

The default return value of has_collect is 0 and collect's default action is do nothing. If defer_collect member is called with nonzero, collect will do nothing (this is only used by the blocked matrices).

Reimplemented from sc::SCElementOp.

void sc::SCElementKNorm::collect | ( | const Ref< SCElementOp > & |  | ) | `[virtual]`

Multithreaded use of cloneable SCElementOp objects requires that data from cloned objects be collected.

The default implementation will throw an exception.

Reimplemented from sc::SCElementOp.

The documentation for this class was generated from the following file:

- elemop.h